#!/bin/sh

# T2C_ROOT is not necessary to run the tests

# Get the directory where this script resides.
WORK_DIR=$(cd `dirname $0` && pwd) 
T2C_SUITE_ROOT=${WORK_DIR}
export T2C_SUITE_ROOT

cd ${T2C_SUITE_ROOT}

#---------------------------------------------------------
#remove previous results and temporaries
rm -rf results
mkdir -p results/0001e

JRNL_FILE=${T2C_SUITE_ROOT}/results/0001e/journal

#run the tests
SEPR="--------------------------------------------------------------"

for SUITE_DIR in *-t2c; do
    echo "Executing tests from the following suite: ${SUITE_DIR}"
    cd ${T2C_SUITE_ROOT}
    for TEST_EXEC in ${SUITE_DIR}/tests/*/*; do
#	echo ${TEST_EXEC}
#	echo -------------
        if [ -x ${TEST_EXEC} ]
        then
	    echo ${SEPR} >> ${JRNL_FILE}
	    echo "Executing ${TEST_EXEC}" >> ${JRNL_FILE}
	    echo >> ${JRNL_FILE}
	    ${TEST_EXEC} >> ${JRNL_FILE}
	    echo ${SEPR} >> ${JRNL_FILE}
        fi
    done
done
