//////////////////////////from common_part.js with little changes
var reAttr = new RegExp ("^[#\$!]*(ext\\.|app\\.)*");
var reRef = new RegExp ("^&");
var reIndex = new RegExp ("(\\.\\d+)$");
var reIndices = new RegExp ("(\\.\\d+)*$");

/*
 * str_id ->
 * .replace(reRef,"") ->
 * .replace(reAttr,"")->
 * id->
 * .replace(reIndeces,"")->
 * function_name
*/

/* 
 * If exist,
 * parent_id == id.replace(reIndex, "")
 */
 
/*
 * reAttr.match(str_id_without_ref) should return array of (some) attribute substrings
 */
var reIDefine = /\[([^\[\]]*)\]/;//match to most-inner unnamed substitution
//var reLine = new RegExp ("(.{0,71}\\S|)(\\s\\n|\\n|\\s)", "g");

// strip symbol '&' from the begining of str_id, if it is.
function stripRef(str_id)
{
	return str_id.replace(reRef,"");
}
//
function isRef(str_id)
{
	return reRef.test(str_id);
}
//
function isApp(str_id)
{
	str_id = stripRef(str_id);
	//
	var attributes = str_id.match(reAttr);
	//return attributes.indexOf("app.") != -1; don't work with Kompozer
	var i;
	for(i in attributes)
	{
		if(attributes[i] == "app.") return true;
	}
	return false;
	
}
//returns object with similar functionality as NodeIterator
function IENodeIterator(element)
{
	this.root = element;
	this.need_child = true;
	this.current = null;
	IENodeIterator.prototype.nextNode = function()
	{
		if(this.current != null)
		{
			while(true)
			{
				if(this.need_child && this.current.firstChild)
				{
					this.current = this.current.firstChild;
					this.need_child = true;
				}
				else if(this.current == this.root)
				{
					//stop
					this.current = null;
				}
				else if(this.current.nextSibling)
				{
					this.current = this.current.nextSibling;
					this.need_child = true;
				}
				else
				{
					this.current = this.current.parentNode;
					this.need_child = false;
					continue;
				}
				break;
			}
		}
		else//current == null
		{
			if(this.need_child)//first call
			{
				this.current = this.root;
			}
		}
		return this.current;
	};
}
function TrimString(sInString)
{
  sInString = sInString.replace( /^\s+/g, "" );// strip leading
  return sInString.replace( /\s+$/g, "" );// strip trailing
}

//for get original formulate of the requirement
//result is string wihtout new-lines; all spaces treated as whitespace;may be other replacement

function getElementText(el, doc)
{
    var result = "";
    try
    {
	    var nodeIterator;
	    if(doc.createTreeWalker)//FireFox
	    {
	    	nodeIterator = doc.createTreeWalker(el,
	    		NodeFilter.SHOW_ELEMENT | NodeFilter.SHOW_TEXT,
	    		null,
	    		false);
	    }
	    else if(doc.NodeIterator)//Opera
	    {
	    	nodeIterator = doc.createNodeIterator(el,
    			NodeFilter.SHOW_ELEMENT | NodeFilter.SHOW_TEXT,
				null,
				false);
	    }//IE
		else
		{
			nodeIterator = new IENodeIterator(el);
		}
		var node;
		while(node = nodeIterator.nextNode())
		{
			if(node.nodeType == 1)//Element
			{
				if(node.className == "form") break;
				else if(node.tagName.toLowerCase() == "br") result += "\n";
			}
			else if(node.nodeType == 3)//Text Node
			{
				result += node.nodeValue;
			}
		}
	}
	catch(error)
	{
		window.alert("getElementText: " + error.message);
	}

    result = TrimString(result).replace(/\s+/g, " ");
    
    return result;
}
function getElementTextAlt(el)
{
	var result = "";
	var lastChild = el.lastChild;
	if(lastChild && lastChild.className == "form")
	{
		//result = lastChild.textContent;
		result = lastChild.firstChild.nodeValue;
		//may be result formatting here
	}
	
	return result;
}
// Strips prefixes from the specified string and returns the result.
function stripPrefixes(str_id)
{
    return str_id.replace(reAttr, "");
}

// returns function name for a given ID
function getfname(id)
{
    return id.replace(reIndices, "");
}
/*
 * For given id, containing(may be) substitutions, named(define) or unnamed
 * returns expansion as array of strings
 * after corresponding substitutions into id.
 */
function expand_subst(id, defines) {
    var ids = new Array(id);
    do {
        var subst_done = true;
        var ids_len = ids.length;
        var new_ids = new Array();
        for(var thisid=0; thisid<ids_len; thisid++ ) {
            var id = ""+ids[thisid];
            var replaced = false;
            //expand unnamed substitutions
            var subst = reIDefine.exec(id);
            if(subst)
            {
            	subst_done = false;
            	first = id.substr(0, subst.index);
            	last = id.substr(subst.index + subst[0].length);
            	var subst_strings = subst[1].split(";");
            	for(var str_i in subst_strings)
            	{
            		var sub_str = subst_strings[str_i];
            		sub_str = sub_str.replace(/^\s+/, "").replace(/\s+$/, "");
            		if(sub_str == "") continue;
            		new_ids.push(first + sub_str + last);
            		replaced = true;
            	}
            	if(!replaced) new_ids.push(first + last);
				continue;//next id
            }
            //expand defines
            for ( var symb in defines ) {
                if ( defines[symb].matcher.test(id)) {
                    replaced = true;
                    subst_done = false;
                    for (var str_i in defines[symb].strings_array) {
                        var str = defines[symb].strings_array[str_i];
                        var id_tmp = id;
                        id_tmp = id_tmp.replace(defines[symb].matcher, str);
                        new_ids.push(id_tmp);
                    }
                    break;
                }
            }
            if (!replaced) {
                new_ids.push(id);
            }
        }
        ids = new_ids;
    }while (!subst_done);
    return ids;
}
//same but for string of ids, rather then for one id
function expand_subst1(id_string, defines)
{
	return expand_subst("[" + id_string + "]", defines);
}
/*
 * Create obj with description of define, containing in html-elemement(elem should have class 'define')
 */

function DefineInfo(elem)
{
	this.symb = "" + elem.name;
    this.strings = "" + elem.title;
}
// return array of string which should be substitute instead of define-name
function split_define_str(str)
{
    //same as req(without defines)
    return expand_subst1(str, null);
}
//return hash-map of defines	
function GetDefines(doc)
{
    var elements_all = doc.getElementsByTagName("a");
    var defines = new Object();
	//var count_defines = 0;
	var length = elements_all.length;
	for(i = 0; i < length; i ++)
	{
		var c = elements_all[i];
		/*if(!c)//FireFox???
		{
			//alert("!!!");
			continue;
		}*/
		if(c.className != "define") continue;
		//count_defines ++;
		var defineInfo = new DefineInfo(c);

        define_object = new Object();
        define_object.matcher = new RegExp(defineInfo.symb, "");
        define_object.strings_array = split_define_str(defineInfo.strings);
        
        defines[defineInfo.symb] = define_object;
	}
	//alert("count of defines is " + count_defines);
    return defines;
}

/*
 * Return obj with description of req, containing in elem(elem should have class 'req'):
 *   - title - (value of property title)
 *   - str_id - string of identificators(value of property id)
 *   - origFormText - original formulation of the requirement
 *   - altFormText - alternative formulation of the requirement, if given. Otherwise "".
 */
function ReqInfo(elem, doc)
{
    this.title = "" + elem.title;
    this.str_id = "" + elem.id;
    // requirement text & its alternative formulation
    this.origFormText = getElementText(elem, doc);
    this.altFormText = getElementTextAlt(elem);
}

/*
 * Return Array(not hash map!) of elements, describing req
 *
 *   - title - (value of property title)
 *   - str_id - string of identificators(value of property id)
 *   - origFormText - original formulation of the requirement
 *   - altFormText - alternative formulation of the requirement, if given. Otherwise "".
 *   - c - html - element, containing this req
 *   - ids - array of ids, formed with expand_subst1(). So one need't document or defines for the next processing of the result of this function.
 */
function GetReqs(doc)
{
	var defines = GetDefines(doc);
	var reqs = new Array();

	try
	{
		var elements_all = doc.getElementsByTagName("span");
		
		//alert("count of elements is " + elements_all.length);
		var length = elements_all.length;
		for(var i = 0; i < length; i++)
		{
			if(i == length - 1) length = elements_all.length;
			var c = elements_all[i];
			/*if(!c)//FireFox???
			{
				continue;
			}*/
			if(c.className == "req")
			{
			
			var req = new ReqInfo(c, doc);
	        req.ids = expand_subst1(req.str_id, defines);
	        req.c = c;
	        reqs.push(req);
	        }
		}
	}
	catch(error)
	{
		alert("GetReqs: " + error.message);
	}
	//alert("Count of reqs: " + reqs.length);
	return reqs;
}
//////////////////////////////////////////////////main script
// JavaScript Document
document.write('<div id="rqth" style="display:none"><h2>Requirements</h2></div>');
document.write('<div id="rqt">&nbsp;</div>');
document.write('<hr size="2" noshade>');
document.write('<div id="show_hide"><a href="javascript:reqShow();">Show Requirements</a></div>');
document.write('<hr size="2" noshade>');

function showhide(id)
{
	var el = document.getElementById(id);
	if(!el)
		return;
	if(el.style.display == "none")
		el.style.display = "";
	else
		el.style.display = "none";
}

//set tag only for current element
function _setTagBg(c, clrName)
{
	if(c.style != null)
	{
		c.style.backgroundColor = clrName;
	}
}
//set tags for current element and all its childrens(and childrens of them, and...)
function setTagBg(c, clrName)
{
	try
	{
		_setTagBg(c, clrName);
			
		var incoll = c.getElementsByTagName("*");
		var length = incoll.length;
		for(var j = 0; j < length; j++)
		{
			_setTagBg(incoll[j],clrName);
		}
	}
	catch(error)
	{
		alert("setTagBg: " + error.message);
	}
}

// if (typeof Element != 'undefined' && Element.prototype && document.createRange)
if (typeof Element != 'undefined' && typeof Element != 'function' && Element.prototype && document.createRange)	 
{
   Element.prototype.__defineGetter__(
     'innerText',
     function () {
       var range = document.createRange();
       range.selectNodeContents(this);
       return range.toString();
     }
   );
   Element.prototype.__defineSetter__(
     'innerText',
     function (text) {
       var range = document.createRange();
       range.selectNodeContents(this);
       range.deleteContents();
       this.appendChild(document.createTextNode(text));
     }
   ); 
 }

function reqHide()
{
	var coll = document.getElementsByTagName("span");

	for(var i=0; i < coll.length; i++)
	{
		var c = coll[i];
		if(c.className != "req") continue;
		
		setTagBg(c, "");
	
		var txt = c.innerHTML;
		if( txt.indexOf("{")==0 )
		{
			txt = txt.substring(txt.indexOf("}")+1);
			c.innerHTML = txt;
		}
	}
	var rqt = document.getElementById("rqt");
	rqt.innerHTML = "";
	
	var showhide = document.getElementById("show_hide");
    showhide.innerHTML = '<a href="javascript:reqShow();">Show Requirements</a>';

}

function showHead()
{
	var showhide = document.getElementById("show_hide"); 
	showhide.innerHTML = '<a href="javascript:hideHead();">Hide head</a>';
}
function hideHead()
{	
	var showhide = document.getElementById("show_hide");
	showhide.innerHTML = '<a href="javascript:reqShow();">Show Requirements</a><br><a href="javascript:showHead();">Show head</a>';
}
//function for sotring table of reqs
function table_sort(a, b)
{
	var id_a = a.id;
	var id_b = b.id;
	
	if(isRef(id_a) == true)
	{
		id_a = stripRef(id_a);
		if(isRef(id_b) == false) return -1;
		id_b = stripRef(id_b);
	}
	else if(isRef(id_b) == true) return 1;
	
	id_a = stripPrefixes(id_a);
	id_b = stripPrefixes(id_b);
	
	return id_a.localeCompare(id_b);
}
function generate_anchor_name(id)
{
	//not inmplement yet(may be needn't)
	return "anch." + id;
}

function reqShow()
{
	try
	{
		reqShow1();
	}
	catch(error)
	{
		alert("error:" + error.message);
	}
}
function reqShow1()
{
	var rqt = document.getElementById("rqt");
	var reqs = GetReqs(document);

	var reqList = new Array();//for table
	var ReqsAddInfo = new Object();//for collision checking
	// 
	var globIDsCollision = false;

	var showhide = document.getElementById("show_hide");
	showhide.innerHTML = '<a href="javascript:reqHide();">Hide Requirements</a><br>';
	//Forms collisions map
	for (var i=0; i < reqs.length; i++)
	{
		var req = reqs[i];
		var ids = req.ids;
		for(var j = 0; j < ids.length; j++)
		{
			var id_string = ids[j];
			if(isRef(id_string) == true) continue;//no process references
			
			var id = stripPrefixes(id_string);
			if(ReqsAddInfo[id]) 
			{
				ReqsAddInfo[id].IDsCollision = true;
				globIDsCollision = true;
			}
			else
			{
				ReqsAddInfo[id] = new Object();
			}
		}
	}
	
	for (var i=0; i < reqs.length; i++)
	{ 
		var req = reqs[i];
		var c = req.c;
		
		var ids = req.ids;
		//Forms reqList
		var txt = req.altFormText != "" ? req.altFormText : req.origFormText;
		for(var j = 0; j < ids.length; j++)
		{
			var idObject = new Object();
			idObject.id = ids[j];
			idObject.c = c;
			idObject.txt = txt;
			
			reqList.push(idObject);
		}
		//prosecc "req"-element
		
		//IE not allow to set 'name' in element created via createElement(), but FireFox doesn't inderstand html instead tag
		//so need function for creating named-element
		document.createNamedElement = function(type, name) {
		  var element;
		  try
		  {
		    element = document.createElement('<'+type+' name="'+name+'">');
		  }
		  catch (e) { }
		  if (!element || !element.name) // Not in IE, then
		  {
		    element = document.createElement(type);
		    element.name = name;
		  }
		  return element;
		}
		//
		var anchor_name = generate_anchor_name(c.id);
		var anchor = document.createNamedElement("a", anchor_name);
		//		
		var anchor_href = "#topanch." + c.id;
		var anchor_title = req.altFormText != "" ? req.altFormText : "";
		
		anchor.setAttribute("href", anchor_href);
		anchor.setAttribute("title", anchor_title);
		
		var bond = document.createElement("b");
		bond.appendChild(document.createTextNode(c.id));
		anchor.appendChild(bond);
		// {anchor}
		c.insertBefore(anchor, c.firstChild);
		c.insertBefore(document.createTextNode("{"), anchor);
		c.insertBefore(document.createTextNode("}"), anchor.nextSibling);		

		if(c.title=="") c.title = c.id; // modifying title.
		setTagBg(c, "#FFFF99"); // highlighting yellow
	}
	var res = "";
	//sorting reqlist
	reqList.sort(table_sort);

	// ----------------------------------------------------
	// res generation. (Requirements table)
	for(var i in reqList)
	{
		var rowInfo = reqList[i];
		var str_id = rowInfo.id;
		var collision_html = "";
		if(!isRef(str_id))
		{
			var id = stripPrefixes(str_id);
			if(ReqsAddInfo[id] && ReqsAddInfo[id].IDsCollision)
				collision_html = " style='color:red'";
		}
		
		var elem = rowInfo.c;
        var href = "#" + elem.firstChild.nextSibling.name;
        
        var txt = reqList[i].txt;
		
		res += "<TR><TD>"+"</TD><TD>{<a name='topanch." + str_id+
		    "' href='" + href + "'"+ collision_html +"><b>"+
			str_id + "</b></a>}"+  "</TD>\n<TD>"+ txt +"</TD></TR>\n";
        
	}
	// end of res generation. (Requirements table)
	// ----------------------------------------------------

	// #defines 
	var defines = GetDefines(document);
	var ndefines = 0;
	var defines_text = '<table border=0>';
	
	for( var symb in  defines) {
		defines_text += '<tr><td><b>'+symb+'</b></td>';
		defines_text += '<td> : '+defines[symb].strings_array.join(', ')+';</td>';
		defines_text += '</tr>';
		ndefines ++;
	}
	defines_text += '</table>'
	//end of #defines

	// General output
	rqt.innerHTML = 
		(globIDsCollision?"<H3 style='color:red'>Warning! IDs collision!</H3>":"")
		+(res?"<h4>Table <a href='javascript:showhide(\"reqs\")'>&gt;&gt;</a></h4><div id='reqs' style='display:none'><table border=1 cellspacing=0 cellpadding=3>"+res+"</table></div>":"")
		+((ndefines > 0)?'<h4>#defines <a href="javascript:showhide(\'_defines\');">&gt;&gt;</a></h4><div id="_defines" style="display:none">'+defines_text+'</div>':"")
	//alert("count of reqs is " + reqs.length);
} // end of reqShow
function hideShowTemplate()
{
    var document = window.document;
    /* show or hide template */
    showhide('rtmph');
    showhide('template');
    var titleEl = document.getElementById('rtmph');
    var showhidetmp = document.getElementById("show_hide_tmp");
    if(showhidetmp != null)
    {
        if( titleEl.style.display == "none")
        {
            showhidetmp.innerHTML = '<div id="show_hide_tmp"><a href="javascript:hideShowTemplate();">Show Template</a></div>';
        }
        else
        {
            showhidetmp.innerHTML = '<div id="show_hide_tmp"><a href="javascript:hideShowTemplate();">Hide Template</a></div>';
        }
    }
}
