#!/usr/bin/perl
use warnings;
use strict;

my $TP_ANCHOR		= "tp";
my $REQ_ANCHOR		= "req";

my $HTML_PREFIX		= "<HTML>\n<HEAD>\n\t<TITLE>Source code<\/TITLE>\n<\/HEAD>\n<BODY>";
my $HTML_SUFIX		= "<\/BODY>\n</HTML>";

my $TP 			= "test_purpose_";
my $TP_4SEARCH1		= "static";
my $TP_4SEARCH2		= "void";
my $TP_4SEARCH3		= "(\\s*)";

my $REQ			= "REQ";
my $TAG_OPEN		= "<.+>";
my $TAG_CLOSE		= "<\/.+>";
my $REQ_4SEARCH1	= "&quot;";


($ARGV[0] and not $ARGV[1]) or die "The program must have only 1 argument from the command line $!\n";

open IN, $ARGV[0] or die "Couldn't open the file: \"$ARGV[0]\" for reading	:$!\n";
open OUT, ">$ARGV[0]\.tmp" or die "Couldn't open the file: \"$ARGV[0]\.tmp\" for writing	:$!\n";

print OUT $HTML_PREFIX;

my $line = -2;
my $line_chkpnt = 0;
my $tp = 0;
my $req_n = 0;
my $print_tp = undef;
my $print_req = undef;
my $print_other;
my $req_time = undef;
my @req = undef;
my $i;

while (<IN>)
{
    $print_other = "rdy";    

    #
    # Check for test_purpose
    #
    $line++;
    if (/$TP_4SEARCH1.+$TP_4SEARCH2.+$TP.+$TP_4SEARCH3/)
    {
	$tp++;
	s/$TP(\d)+/<a name=\"$TP_ANCHOR$tp\">$TP$tp<\/a>/;
	$print_tp = "rdy";
	$print_other = undef;
    }

    #
    # Check for REQ
    #
    if (/$REQ$TAG_CLOSE\s*\($TAG_OPEN\s*$REQ_4SEARCH1/)
    {
	s/$REQ/<a name=\"$REQ_ANCHOR\">$REQ<\/a>/;
	$req[$req_n++] = $_;
	$line_chkpnt = $line;
	$print_other = undef;
	$req_time = "was in req";
    }
    if ($req_time)
    {    
	if (/\)\;\s*\n\s*$/)
	{    
	    $req[0] =~ s/<a name=\"$REQ_ANCHOR\">$REQ<\/a>/<a name=\"$REQ_ANCHOR$line\">$REQ<\/a>/;
	    $print_req = "rdy";	    
	}
	if ($line ne $line_chkpnt)
	{
	    $req[$req_n++] = $_;
	}
	$print_other = undef;
    }
    
    #
    # Print test_purpose line
    #
    if ($print_tp)
    {
	print OUT "$_";
	$print_tp = undef;
    }
    
    #
    # Print REQ lines
    #
    if ($print_req)
    {
	$i = 0;
	while ($i < $req_n)
	{
	    print OUT $req[$i++];
	}	
	@req = undef;
	$req_n = 0;
	$print_req = undef;
	$req_time = undef;
    }
    
    #
    # Print other lines
    #
    if ($print_other)
    {
	print OUT $_;
    }
}

print OUT $HTML_SUFIX;










