/**
 *    * Name: ct2chtml
 *    * Description: HTML for t2c generated C file.
 *    * Author: SSDK <ssdk@ispras.ru>
 *    * ...
**/

state lang_ct2chtml
{
  BEGIN {
    /* RGB -> HTML color mapper function. */
    sub map_color (r, g, b)
      {
	return sprintf ("#%02X%02X%02X", r, g, b);
      }

    LANGUAGE_SPECIALS = /[<>\&\"]/;

    sub language_print (str)
      {
	str = regsuball (str, /\&/, "&amp;");
	str = regsuball (str, /</, "&lt;");
	str = regsuball (str, />/, "&gt;");
	str = regsuball (str, /\"/, "&quot;");
	print (str);
      }

    sub language_symbol (symbol)
      {
	return false;
      }

    sub header ()
      {
	print ("\n<PRE style='font-size:9pt'>\n");
      }

    sub trailer ()
      {
	print ("</PRE>\n");
      }

    sub face_on (face)
      {
	if (face[boldp])
	  print ("<B>");
	if (face[italicp])
	  print ("<I>");

	if (face[fg_color])
	  print ("<FONT COLOR=\"", face[fg_color], "\">");
	/* The background color is not supported in HTML. */
      }

    sub face_off (face)
      {
	if (face[fg_color])
	  print ("</FONT>");

	if (face[italicp])
	  print ("</I>");
	if (face[boldp])
	  print ("</B>");
      }

    return;
  }
}


/*
Local variables:
mode: c
End:
*/
