#!/usr/bin/perl
use warnings;
use strict;

my $TAB			= ";\t\t";

my $LIB_TAG		= "This file contains tests for the following library:";
my $TP_TAG		= "Target interfaces:";
my $STATUS		= "target";


my $test_path;
my $tp_num = 0;
my $libtag = undef;
my $lib;
my $tptag = undef;
my @tp = undef;
my $tp_n = 0;
my $print_line = undef;

#
# Checkin the parameters
#
($ARGV[0] and $ARGV[1] and $ARGV[2] and not $ARGV[3]) or die "The program must have 3 argument from the command line $!\n";

#
# Opening files to read and write (append)
#
open IN, $ARGV[0] or die "Couldn't open the file: \"$ARGV[0]\" for reading	:$!\n";
open OUT, ">>$ARGV[1]" or die "Couldn't open the file: \"$ARGV[1]\" for writing	:$!\n";

$test_path = $ARGV[2];
while (<IN>)
{
    #
    # Getting $lib
    #
    if ($libtag)
    {
	s/[\/\,\s]//g;
	$lib = $_;
	$libtag = undef;
    }
    if (/^(\/*\s*$LIB_TAG\s*)$/)
    {
	$libtag = "Found LIB_TAG"
    }
    
    #
    # Getting @tp
    # and $print_line
    #
    if ($tptag)
    {
	if (/^(\/*\s+)$/)
	{
	    $tptag = undef;
	    $print_line = "It's time to print";
	}
	else
	{
	    s/[\/\s]//g;
    	    $tp[$tp_n++] = $_;
	}
    }
    if (/^(\/*\s*$TP_TAG\s*)$/)
    {    
	$tptag = "Found TP_TAG";
	$tp_num++;
    }    
    
    #
    # Printing the line
    #
    if ($print_line)
    {
	for (@tp)
	{
	    print OUT $lib.$TAB.$_.$TAB.$test_path." ".$tp_num.$TAB.$test_path.".c".$TAB.$STATUS."\n";
	}    
	$print_line = undef;
	@tp = undef;
	$tp_n = 0;
    }
}











